unit ModPlugPlayer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TModPlugPlayer = class(TPanel)
  private
    sik:boolean;
    hiden:boolean;
    loop:boolean;
    filename:tfilename;
    stereo:boolean;
    player: pointer;
    playing:boolean;
    fonload:TNotifyEvent;
    foninit:TNotifyEvent;
    fonstop:TNotifyEvent;
   { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor destroy; override;
    procedure init;
    procedure deinit;
    procedure play;
    procedure stop;
    function ready: bool;
    function open: bool;
    function isplaying: bool;
    function version: dword;
    function getlength: dword;
    function getposition: dword;
    function Setposition(gotopos:integer): bool;
  published
    property HideVUmeter : boolean read hiden write hiden;
    property LoopSong : boolean read loop write loop;
    property StereoVUmeter : boolean read stereo write stereo;
    property SongName : tfilename read filename write Filename;
    property Seek : boolean read sik write sik;
    property OnLoad : TNotifyEvent read FOnLoad write FOnLoad;
    property OnInit : TNotifyEvent read FOnInit write FOnInit;
    property OnStop : TNotifyEvent read FOnStop write FOnStop;
    { Published declarations }
  end;


function CreateIt(parms : string) : pointer;stdcall;external 'npmod32.dll' name 'ModPlug_CreateEx'; {give her sum life!}
function LoadIt(plug : pointer;filename : string) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_Load'; {load her}
function PlayIt (it : pointer) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_Play'; {play it!}
function SetW(plug : pointer;hand : hwnd) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_SetWindow'; {assigns the plugin to the control}
function IsRead(plug : pointer) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_IsReady'; {am i ready to rocknroll?}
function DestroyIt(plug : pointer) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_Destroy'; {destroys pointer and player}
function StopIt(plug : pointer) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_Stop'; {stops the mod player}
function SetPos(plug : pointer; pos : word) : boolean;stdcall;external 'npmod32.dll' name 'ModPlug_SetCurrentPosition'; {set position}
function GetMaxPos(plug : pointer) : word;stdcall;external 'npmod32.dll' name 'ModPlug_GetMaxPosition'; {position}
function GetCurPos(plug : pointer) : word;stdcall;external 'npmod32.dll' name 'ModPlug_GetCurrentPosition'; {position}
function GetVersion:longint;stdcall;external 'npmod32.dll' name 'ModPlug_GetVersion';


  procedure Register;

implementation
Constructor TModPlugPlayer.create(AOwner: TComponent);
begin
  inherited Create(Aowner);    //
  player:= nil;
  self.width:=169;
  self.height:=49;
end;

destructor TModPlugPlayer.Destroy;
begin
   deinit;
   inherited Destroy;
end;

procedure TModPlugPlayer.deinit;
begin
   if player = nil then exit;
   destroyit(player);
   player:=nil
end;

procedure tModPlugPlayer.init;
var
 hidden,lup,str:string;
begin
if player <> nil then deinit;
if hiden = true then hidden:='true'
  else hidden:='false';
if loop = true then lup:='true'
  else lup:='false';
if stereo = true then str:='|controls|stereo';
//----------------
player:= createit('hidden|'+hidden+'|width|'+inttostr(self.width)+'|height|'
  +inttostr(self.height)+'|loop|'+lup+str);
setw(player,tpanel(self).handle);
if assigned(FOnInit) then FOnInit(self);
end;

procedure tModPlugPlayer.play;
begin
if player = nil then exit;
playit(player);
playing:=true;
if assigned(FOnLoad) then FOnLoad(self);
end;

function tModPlugPlayer.ready: bool;
begin
if player <> nil then result:=isread(player)
else result:=false;
end;

function tModPlugPlayer.open: bool;
begin
if player <> nil then
begin;
if filename <> '' then loadit(player,filename);
end;
result:= isread(player);
end;

function tModPlugPlayer.isplaying: bool;
begin
result:= playing;
end;

function tModPlugPlayer.version: longint;
 begin
  result:=getversion;
 end;

function tModPlugPlayer.getlength: Dword;
begin
if player <> nil then
begin;
result:=getmaxpos(Player);
end
else result:=0;
end;

function tModPlugPlayer.getposition: Dword;
begin
if player <> nil then
begin;
result:=getcurpos(Player);
end
else result:=0;
end;

function tModPlugPlayer.Setposition(gotopos: integer): bool;
begin
if not sik then result:=false;
if not sik then exit;
if player = nil then
begin
result:=false;
exit;
end;
  if gotopos < getmaxpos(Player) then
  begin
  result:=setpos(Player, gotopos);
  end
  else
  result:=false;
end;

procedure tModPlugPlayer.stop;
begin
if player <> nil then
begin;
stopit(player);
playing:=false;
if assigned(FOnstop) then FOnstop(self);
end;
end;

procedure Register;
begin
  RegisterComponents('Multimedia', [TModPlugPlayer]);
end;

end.
